package graphomat.graph;
import java.util.*;
import graphomat.graph.*;
/**
 *This class is used by the <code>GraphFrame</code> but can withoutt any changes
 *be used in any other class. 
 */
public class Clipboard{
  Graph g;
  double pasteMove = 0, 
  	move = 0,
  	percentAdd = 1.2;
	public Clipboard() {}
	
	/**Copies all Nodes and Edges of the <code>SubGraph</code>.*/
	public void copy(SubGraph sg) {
		Enumeration ee = sg.getEdgeEnum(),
			en = sg.getNodeEnum();
		SubGraph osg;
		Hashtable t = new Hashtable();
		Node n1, n2, on1, on2;
		Edge e,oe;
		double x,y;
		g = new Graph();
		osg = g.getSelection();
		while (en.hasMoreElements()){
			n1 = (Node)en.nextElement();
			on1 = new Node(n1.getx(), n1.gety());
			g.addNode(on1);
			t.put(n1,on1);
		}
		oe = (Edge)ee.nextElement();
		while (ee.hasMoreElements()){
			e = oe;
			oe = (Edge)ee.nextElement();		
			n1 = e.getn1();	n2 = e.getn2();
			on1 = (Node)t.get(n1); on2 = (Node)t.get(n2);
			on1.connect(on2);
		}
		x = osg.getMaxX() - osg.getMinX();
		y = osg.getMaxY() - osg.getMinY();
		move = (x > y)?x:y;
		move *= percentAdd;
		if (move == 0) move = 5;
		pasteMove = 0;
	}
	
	/**
	 *Deletes all Nodes and Edges which are both in the <code>Graph</code>
	 *and in the <code>SubGraph</code>.
	 */
	public void clear(Graph og, SubGraph sg) {
		Enumeration en = sg.getNodeEnum();
		Node n;
		while (en.hasMoreElements()){
			n = (Node)en.nextElement();
			og.deleteNode(n);
			n = null;
		}
  }		
  
  /**Copies and deletes in one operation.*/
	public void cut(Graph og, SubGraph sg) {
		copy(sg);
		clear(og, sg);
		pasteMove = 0;
	}
	
	/**Pastes the stored Nodes and Edges back into a given <code>Graph</code>.*/
	public void paste(Graph og) {
		Enumeration ee = g.getEdgeEnum(),
			en = g.getNodeEnum();
		Hashtable t = new Hashtable();
		Node n1, n2, on1, on2;
		Edge e;
		pasteMove += move;
		while (en.hasMoreElements()){
			n1 = (Node)en.nextElement();
			on1 = new Node(n1.getx()+pasteMove, n1.gety()+pasteMove);
			og.addNode(on1);
			t.put(n1,on1);
		}
		while (ee.hasMoreElements()){
			e = (Edge)ee.nextElement();
			n1 = e.getn1();	n2 = e.getn2();
			on1 = (Node)t.get(n1); on2 = (Node)t.get(n2);
			on1.connect(on2);
		}
	}
}