package	graphomat.graph.algorithms;

import graphomat.graph.*;
import graphomat.graph.random.*;
import java.lang.*;
import java.util.*;

public class CrossAlgo implements Runnable {
	private SubGraph g;

	public CrossAlgo(SubGraph g) {this.g = g;}
	public void run() {place();}
	
	private int ccw(Node n0,Node n1,Node n2){
	    double dx1,dx2,dy1,dy2;
	    
	    dx1 = n1.getx() - n0.getx();
	    dy1 = n1.gety() - n0.gety();
	    dx2 = n2.getx() - n0.getx();
	    dy2 = n2.gety() - n0.gety();
	    if(dx1*dy2>dy1*dx2) return 1;
	    if(dx1*dy2<dy1*dx2) return -1;
	    if((dx1*dx2<0) || (dy1*dy2<0)) return -1;
	    if((dx1*dx1+dy1*dy1)<(dx2*dx2+dy2*dy2)) return 1;
	    return 0;
	}
	
	private boolean intersect(Edge e1,Edge e2){
	    return((ccw(e1.getn1(),e1.getn2(),e2.getn1())
	           *ccw(e1.getn1(),e1.getn2(),e2.getn2())) <=0)
	       && ((ccw(e2.getn1(),e2.getn2(),e1.getn1())
	           *ccw(e2.getn1(),e2.getn2(),e1.getn2())) <=0);
	}
	
	private int getCrossings(SubGraph g){
	    Enumeration	enum,enum2;
	    Edge e,en;
	    enum = g.getEdgeEnum();
	    int i = 0,j,crosscounter = 0;
	    while (enum.hasMoreElements()) {
	        enum2 = g.getEdgeEnum();
			e = (Edge)enum.nextElement();
			i++; j = 0;
			while (enum2.hasMoreElements()) {
			    en = (Edge)enum2.nextElement();
			    j++;
			    if (j>i && !e.toucheEdge(en)){
			        if(intersect(e,en)) crosscounter++;
			    }
			}
        }
        return crosscounter;
	}

	public void place(){
		CalculationTime	ct = new CalculationTime(5000);
		// Time	in ms: 1000	is 1 second.

		Enumeration	enum;
		Node n1 = new Node(0,0)
			,n2 = new Node(0,0)
			,n3;
	    double crosscount1 = 0,crosscount2 = 0;
		Date datum = new Date();
		long end = datum.getTime() + ct.Get();
		do{
			int nbnodes = g.getNodeCount();
			RandomNode rn = new RandomNode(nbnodes);
			int r1 = rn.Get1();
			int r2 = rn.Get2();
			int i = 0;
			enum = g.getNodeEnum();
			while (enum.hasMoreElements()) {
				i++;
				n3 = (Node)enum.nextElement();
				if(i==r1) n1 = n3;
				if(i==r2) n2 = n3;
			}
			crosscount1 = getCrossings(g);
			n1.setNotifyMove(false);
			n2.setNotifyMove(false);
			n1.swap(n2);
			crosscount2 = getCrossings(g);
			if (crosscount1 < crosscount2) n1.swap(n2);
			n1.setNotifyMove(true);
			n2.setNotifyMove(true);
			Thread.currentThread().yield(); 
		}while(System.currentTimeMillis() < end && crosscount1>0);
	}
}
