package	graphomat.graph.algorithms;

import graphomat.graph.*;
import java.lang.*;
import java.util.*;
import graphomat.gui.*;

public class DoubleCircleMiddleAlgo{
	private SubGraph g;

	public DoubleCircleMiddleAlgo(SubGraph g) {this.g = g;}

    double angle,radiusi,radiuso,alpha=0,midx,midy;
    long counter=0;
    int innercircle,outercircle;

	public void place(){
	    class SetTraverserOuter extends NodeTraverser {
	        boolean flag = false;
			public void processNode(Node n) {
			    double x=0,y=0;
			    n.set(midx,midy);
			    counter++;
			    if(flag && counter<=outercircle) {
    			    x = midx+(radiuso*Math.cos(alpha));
    			    y = midy+(radiuso*Math.sin(alpha));
    				n.set(x,y);
    				alpha += angle;
				}
				else if (!flag) {
				    flag=true;
				    n.set(midx,midy);
				}
			}
		}
		class SetTraverserInner extends NodeTraverser {
			public void processNode(Node n) {
			    double x=0,y=0;
			    counter++;
			    if(counter>outercircle) {
    			    x = midx+(radiusi*Math.cos(alpha));
    			    y = midy+(radiusi*Math.sin(alpha));
    				n.set(x,y);
    				alpha += angle;
				}
			}
        }
        
		NormalAlgo n = new NormalAlgo(g);
		if (g.getNodeCount() % 2 == 0){
		    innercircle = g.getNodeCount() / 2;
		    outercircle = innercircle;
		}
		else{
		    innercircle = (g.getNodeCount() - 1) / 2;
		    outercircle = innercircle + 1;
		}
		
		SetTraverserOuter travo = new SetTraverserOuter();
		SetTraverserInner travi = new SetTraverserInner();
		angle = 2 * Math.PI / innercircle;
		midx = g.getMaxX() - g.getMinX();
		midy = g.getMaxY() - g.getMinY();
		if(midx<midy) radiuso = midx;
		else radiuso = midy;
		radiusi=radiuso/2;
		g.traversNodes(new SetTraverserOuter());
		alpha=angle/2; counter=0;
		g.traversNodes(new SetTraverserInner());
	}
}
