package	graphomat.graph.algorithms;

import graphomat.graph.*;
import graphomat.util.*;
import graphomat.graph.random.*;
import java.lang.*;
import java.util.*;
import graphomat.gui.*;

public class DynaSpringAlgo implements Runnable{
	private SubGraph g;
    
	public DynaSpringAlgo(SubGraph g) {this.g = g;}
	public void run() {place();}
	
	private int howManyEdges(Node n) {
		Enumeration enum;
		Node nd;
		int nb = 0;

		enum = g.getNodeEnum();
	  	while (enum.hasMoreElements()) {
	   		nd = (Node)enum.nextElement();
	   		if (n.isConnected(nd)) nb++;
	   }
	   return nb;
	}

	final static int optl = 8;
	final static double friction = 0.6;
    
	public void place(){
	    CalculationTime	ct = new CalculationTime(5000);
		// Time	in ms: 1000	is 1 second.
    	Enumeration enum;
		Node n1 = new Node(0,0)
		    ,n2 = new Node(0,0)
		    ,n3;
		double l,x1=0,x2=0,y1,y2,x=0,y=0,newl=0,alpha,moveunit,movedist1,movedist2;
		double movedist1x,movedist1y,movedist2x,movedist2y;
		double ax1=0,ay1=0,ax2=0,ay2=0,bx1=0,by1=0,bx2=0,by2=0;
		double cx1=0,cy1=0,cx2=0,cy2=0,temp1x,temp1y,temp2x,temp2y;
		int connectionNb1,connectionNb2;
		Date datum = new Date();
        long end = datum.getTime() + ct.Get();
		
		do{
    		int nbnodes = g.getNodeCount();
    		RandomNode rn = new RandomNode(nbnodes);
    		int r1 = rn.Get1();
        	int r2 = rn.Get2();
    		int i = 0;
        	enum = g.getNodeEnum();
        	
        	while (enum.hasMoreElements()) {    // Get 2 Random Points
        		i++;
        		n3 = (Node)enum.nextElement();
        		if(i==r1) n1 = n3;
        		if(i==r2) n2 = n3;
        	}    
        	    x1 = n1.getx(); x2 = n2.getx();
        	    y1 = n1.gety(); y2 = n2.gety();
        	    ax1 = n1.getax(); ax2 = n2.getax();
        	    ay1 = n1.getay(); ay2 = n2.getay();  
        	    
        	    x = Math.max(x1,x2) - Math.min(x1,x2);
        	    if(x==0) x=0.000001;
        	    y = Math.max(y1,y2) - Math.min(y1,y2);
        	    l = Math.sqrt(x*x + y*y);
            	
            	//System.out.println("Alte Lnge: " + l);
            	
            	if(l>optl) newl=l-(l-optl)*0.03;    //Intensitt der Feder 0.03
            	else newl=optl-(optl-l)*0.97; 
            	                                    //                     0.97
            	                                    //                     ----
            	                                    //                     1.00
            	//System.out.println("Neue Lnge: " + newl);
            	connectionNb1 = howManyEdges(n1);
            	connectionNb2 = howManyEdges(n2);

            	alpha = Math.atan(y/x);             // Angle in Radians
            	//System.out.println("alpha: " + alpha);
            	moveunit = (l-newl)/(connectionNb1+connectionNb2 + 2);
            	movedist1 = (moveunit * connectionNb2) + moveunit; 
            	movedist2 = (moveunit * connectionNb1) + moveunit; 
            	movedist1x = movedist1 * Math.cos(alpha); 
            	movedist1y = movedist1 * Math.sin(alpha); 
            	movedist2x = movedist2 * Math.cos(alpha); 
            	movedist2y = movedist2 * Math.sin(alpha);
            	
            	if(x1<x2)
            	{
            	    if(y1<y2)
            	    {                          // x1 on the left
                	    temp1x = x1 + movedist1x; temp1y = y1 + movedist1y;
                	    temp2x = x2 - movedist2x; temp2y = y2 - movedist2y;
                	}
                	else
                	{                           // x2 on the left
                	    temp1x = x1 + movedist1x; temp1y = y1 - movedist1y;
                	    temp2x = x2 - movedist2x; temp2y = y2 + movedist2y;
                	}
                }
                else{
                    if(y1<y2)
            	    {                          // x1 on the left
                	    temp1x = x1 - movedist1x; temp1y = y1 + movedist1y;
                	    temp2x = x2 + movedist2x; temp2y = y2 - movedist2y;
                	}
                	else
                	{                           // x2 on the left
                	    temp1x = x1 - movedist1x; temp1y = y1 - movedist1y;
                	    temp2x = x2 + movedist2x; temp2y = y2 + movedist2y;
                	}
                }
                
                bx1 = temp1x - x1; by1 = temp1y -y1;
                bx2 = temp2x - x2; by2 = temp2y -y2;
                
                cx1 = (ax1 + bx1)*friction;  //Reibung
                cy1 = (ay1 + by1)*friction;
                cx2 = (ax2 + bx2)*friction;
                cy2 = (ay2 + by2)*friction;
                
                if(x1+cx1>0 && y1+cy1>0) {n1.setax(cx1); n1.setay(cy1); n1.move(cx1,cy1);}
                if(x2+cx2>0 && y2+cy2>0) {n2.setax(cx2); n2.setay(cy2); n2.move(cx2,cy2);}
                Thread.currentThread().yield(); 

    	 }while(System.currentTimeMillis() <	end);
	}
}