package	graphomat.graph.algorithms;

import graphomat.graph.*;
import graphomat.graph.algorithms.*;
import graphomat.graph.random.*;
import java.lang.*;
import java.util.*;

public class NormalAlgo implements Runnable {
	private SubGraph g;

	public NormalAlgo(SubGraph g) {this.g = g;}
	public void run() {place();}
	
	private double calcLength(Node n) {
		Enumeration enum;
		Edge e;
		double length = 0;

		enum = n.getEdgeEnum();
	  	while (enum.hasMoreElements()) {
	   		e = (Edge)enum.nextElement();
	   		if (g.inGraph(e.otherThan(n))) length += e.getLength();
	   }
	   return length;
	}

	public void place(){
		CalculationTime	ct = new CalculationTime(5000);
		// Time	in ms: 1000	is 1 second.

		double l = 0;
		Enumeration	enum;
		Node n1 = new Node(0,0)
			,n2 = new Node(0,0)
			,n3;
        
        if (g.getNodeCount() >= 2){     //Minimal Nodes to place.
    		Date datum = new Date();
    		long end = datum.getTime() + ct.Get();
    		do{
    			int nbnodes = g.getNodeCount();
    			RandomNode rn = new RandomNode(nbnodes);
    			int r1 = rn.Get1();
    			int r2 = rn.Get2();
    			int i = 0;
    			enum = g.getNodeEnum();
    			while (enum.hasMoreElements()) {
    				i++;
    				n3 = (Node)enum.nextElement();
    				if(i==r1) n1 = n3;
    				if(i==r2) n2 = n3;
    			}
    			l = calcLength(n1) + calcLength(n2);
					n1.setNotifyMove(false);
					n2.setNotifyMove(false);
    			n1.swap(n2);
    			if (l < calcLength(n1) + calcLength(n2)) n1.swap(n2);
					n1.setNotifyMove(true);
					n2.setNotifyMove(true);
					Thread.currentThread().yield(); 
    		}while(System.currentTimeMillis() <	end);
    	}
	}
}