package graphomat.gui;
import java.io.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.zip.*;
import com.sun.java.swing.*;
import graphomat.graph.*;
import graphomat.graph.random.*;
import graphomat.graph.algorithms.*;
import graphomat.gui.*;

public class GraphFrame extends JFrame{
	class HelpFrame extends JFrame {
		HtmlPane html = new HtmlPane();
		JPanel p = new JPanel();
		public HelpFrame() {
			p.setLayout(new BorderLayout());
			p.add("Center",html);
			getContentPane().add(p);
		}
	}
	class GraphFilter implements FilenameFilter {
		public boolean accept(File dir, String name) {
			return(true);
		}
	}
	String version = new String("1.01");
	String path = new String("images");
	String suffix = new String("gif");
	String filename = "";
	String ABOUTMSG =	"      Graph'o->mat\n\n"
	                + "Programmers:\n"
	                + "- Thomas Schdler\n- Tobias Teuffer\n- Paul Jaros\n"
	                + "\n\n      V " + version + " June 98";
	JPanel tbp = new JPanel(),
		cp = new JPanel();
	JRootPane rp = new JRootPane();
	JMenuBar mb = new JMenuBar();
	JMenu mf,	me,	mg, ma, mh;
	JMenuItem mifn,	mifo,	mifsa, mifs, mifq, miecu, mieco, miepa,	mies,
		mied,	mias,	miaci, miace,	miacr, miasp, miad,	miag, mihh,	miha;
	JRadioButtonMenuItem mige, miadn, miade;
	ButtonGroup bg = new ButtonGroup();
	JToolBar tb = new JToolBar();
	JLabel status = new JLabel("Welcome to Graphomat V " + version);
	JButton bn, bo, bs, bcu, bco, bpa, baci, bacr, basp;
	ImageIcon in, io, is, icu, ico, ipa, iaci, iacr, iasp;
	Toolkit tk = Toolkit.getDefaultToolkit();
	HtmlPane html = new HtmlPane();
	public JGraphCanvas gc;
	Graph g;
	SubGraph sg;
	Clipboard cb = new Clipboard();
		
	ActionListener alnew = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onNew();}},
		alopen = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onOpen();}},
		alsaveas = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onSaveAs();}},
		alsave = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onSave();}},
		alcut = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onCut();}},
		alcopy = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onCopy();}},
		alpaste = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onPaste();}},
		alsall = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onSall();}},
		aldall = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onDall();}},
	  alee = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onSelectEdit();}},
	  aladn = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onSelectADNode();}},
	  alade = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onSelectADEdge();}},
		alas = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onAStandard();}},
		alaci = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onACircle();}},
		alce = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onADCircle();}},
		alcr = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onACross();}},
		als = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onASpring();}},
		ald = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onADynaSpring();}},
		alg = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onGenerate();}},
		alhh = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onHelp();}},
		alha = new ActionListener() {
			public void actionPerformed(ActionEvent e) {onAbout();}};
	
	protected void onNew() {
		setGraph(new Graph());
		status.setText("Clearing");
		filename="";
	}
	protected void onOpen() {
		Graph og = new Graph(),
			ng = new Graph();
		Clipboard dcp = new Clipboard();
		FileDialog fd = new FileDialog(this,"Load");
		fd.setFilenameFilter(new GraphFilter());
		fd.show();
		if (fd.getFile().length()>0) {
			status.setText("Opening: " + fd.getFile());
			filename = fd.getFile();
			try {	
				ObjectInputStream ois = 
					new ObjectInputStream(
						new GZIPInputStream(
							new FileInputStream(fd.getFile())));
				og = (Graph)ois.readObject();
				ois.close();
				dcp.copy(og.getSelection());
				dcp.paste(ng);
				setGraph(ng);
			} catch(Exception e) {System.out.println(e);}
		} else {status.setText("Open abordet");}
	}
	protected void onSaveAs() {
		FileDialog fd = new FileDialog(this,"Saving As..");
		fd.setFilenameFilter(new GraphFilter());
		fd.show();
		if (fd.getFile().length()>0) {
			status.setText("Saveing: " + fd.getFile());
			filename = fd.getFile();
			onSave();
		} else {status.setText("Save abordet");}
	}
	protected void onSave() {
		if (filename.length() < 1) {
			FileDialog fd = new FileDialog(this,"Save");
			fd.setFilenameFilter(new GraphFilter());
			fd.show();
			filename = fd.getFile();
		}
		if (filename.length() != 0) {
			try {
				ObjectOutputStream oos =
					new ObjectOutputStream(
						new GZIPOutputStream(
							new FileOutputStream(filename)));
				oos.writeObject(getGraph());
				oos.close();
			} catch(Exception e) {System.out.println(e);}
		}	else {status.setText("Save abordet");}
	}
	protected void onExit()	{System.exit(0);}
	protected void onCut() {
		if (gc.clip.getNodeCount()>0) {
			cb.cut(g,gc.clip);
			status.setText("Cut");
		}
	}
	protected void onCopy() {
		if (gc.clip.getNodeCount()>0) {
			cb.copy(gc.clip);
			status.setText("Copy");
		}
	}
	protected void onPaste() {
		if (gc.clip.getNodeCount()>0) {
			cb.paste(g);
			status.setText("Paste");
		}
	}
	protected void onSall() {
		gc.selectAll();
		status.setText("Everything Selected");
	}
	protected void onDall() {
		gc.deselectAll();
	status.setText("Everything Deselected");
	}
	protected void onSelectEdit() {status.setText("Edit Mode"); gc.setMode(1);}
	protected void onSelectADNode() {status.setText("Add/Delete Node Mode"); gc.setMode(2);}
	protected void onSelectADEdge() {status.setText("Add/Delete Edge Mode"); gc.setMode(3);}	
	protected void onAStandard() {
		status.setText("Standard Algorithm");
		NormalAlgo n = new NormalAlgo(getSelection());
		Thread t = new Thread(n); t.start();}
	protected void onACircle() {
		CircleAlgo c = new CircleAlgo(getSelection());
		c.place(); status.setText("Circle Algorithm");}
	protected void onADCircle() {
		DoubleCircleMiddleAlgo dcm = new DoubleCircleMiddleAlgo(getSelection());
		dcm.place(); status.setText("Centered 2-Circle Algorithm");}
	protected void onACross() {
		status.setText("Cross Algorithm");
		CrossAlgo cross = new CrossAlgo(getSelection());
		Thread t = new Thread(cross); t.start();}
	protected void onASpring() {
		status.setText("Spring Algorithm");
		SpringAlgo sp = new SpringAlgo(getSelection());
		Thread t = new Thread(sp); t.start();}
	protected void onADynaSpring() {
		status.setText("DynaSpring Algorithm");
		DynaSpringAlgo dyna = new DynaSpringAlgo(getSelection());
		Thread t = new Thread(dyna); t.start();}
	protected void onGenerate() {
		status.setText("Generating random Graph");
		Graph g = new Graph();
		RandomGraph rg = new RandomGraph();
		rg.make(g,80);
		setGraph(g);
		filename = "";
	}
	protected void onHelp() {
		HelpFrame hf = new HelpFrame();
		hf.setSize(640,480);
		hf.show();
	}
	protected void onAbout() {
		JOptionPane.showMessageDialog(this, ABOUTMSG);
	}
	
	private ImageIcon makeImage(String name){
		Image img = null;
		try {
			InputStream streamNew = getClass().getResourceAsStream(path 
				+ "/" + name + "." + suffix);	
			byte imageBytes[] = new byte[streamNew.available()];
			streamNew.read(imageBytes);
			img = tk.createImage(imageBytes);
		} catch(IOException e) {
			System.err.println("On: " + path + "/" + name + "." + suffix + "\n" + e);
		}
		return new ImageIcon(img);
	}
	
	private SubGraph getSelection(){
		return (gc.clip.getNodeCount()>0)?gc.clip:g.getSelection();
	}
		
	public GraphFrame(String title, Graph g) {
		super(title);
		this.g = g;
		sg = g.getSelection();		
		gc = new JGraphCanvas(g);
		Container c = getContentPane();
		in = makeImage("new");
		io = makeImage("open");
		is = makeImage("save");
		icu = makeImage("cut");
		ico = makeImage("copy");
		ipa = makeImage("paste");
		iaci = makeImage("alcirc");
		iacr = makeImage("alcros");
		iasp = makeImage("alspri");
		
		bn = new JButton(in);
		bo = new JButton(io);
		bs = new JButton(is);
		bcu = new JButton(icu);
		bco = new JButton(ico);
		bpa = new JButton(ipa);
		baci = new JButton(iaci);
		bacr = new JButton(iacr);
		basp = new JButton(iasp);
		
		mf = new JMenu("File");
		mf.setMnemonic('F');
		me = new JMenu("Edit");
		me.setMnemonic('E');
		mg = new JMenu("Graph");
		mg.setMnemonic('G');
		ma = new JMenu("Algorithm");
		ma.setMnemonic('A');
		mh = new JMenu("Help");
		mh.setMnemonic('H');
		
		mifn = new JMenuItem("New",in);
		mifn.setHorizontalTextPosition(JButton.RIGHT);
		mifn.setMnemonic('N');
		mifo = new JMenuItem("Open",io);
		mifo.setHorizontalTextPosition(JButton.RIGHT);
		mifo.setMnemonic('O');
		mifsa = new JMenuItem("Save As..");
		mifsa.setMnemonic('A');
		mifs = new JMenuItem("Save",is);
		mifs.setHorizontalTextPosition(JButton.RIGHT);
		mifs.setMnemonic('S');
		mifq = new JMenuItem("Quit");
		mifq.setMnemonic('Q');
		miecu = new JMenuItem("Cut",icu);
		miecu.setHorizontalTextPosition(JButton.RIGHT);
		miecu.setMnemonic('C');
		mieco = new JMenuItem("Copy",ico);
		mieco.setHorizontalTextPosition(JButton.RIGHT);
		mieco.setMnemonic('o');
		miepa = new JMenuItem("Paste",ipa);
		miepa.setHorizontalTextPosition(JButton.RIGHT);
		miepa.setMnemonic('P');
		mies = new JMenuItem("Select All");
		mies.setMnemonic('e');
		mied = new JMenuItem("Deselect All");
		mied.setMnemonic('D');
		mias = new JMenuItem("Standard");
		mias.setMnemonic('S');
		miaci = new JMenuItem("Circle");
		miaci.setMnemonic('i');
		miace = new JMenuItem("Centered 2 Circle",iaci);
		miace.setHorizontalTextPosition(JButton.RIGHT);
		miace.setMnemonic('C');
		miacr = new JMenuItem("Cross",iacr);
		miacr.setHorizontalTextPosition(JButton.RIGHT);
		miacr.setMnemonic('r');
		miasp = new JMenuItem("Spring");
		miasp.setMnemonic('S');
		miad = new JMenuItem("DynaSpring",iasp);
		miad.setHorizontalTextPosition(JButton.RIGHT);
		miad.setMnemonic('D');
		miag = new JMenuItem("Generate Random Graph");
		miag.setMnemonic('G');
		mihh = new JMenuItem("Help");
		mihh.setMnemonic('H');
		miha = new JMenuItem("About");
		miha.setMnemonic('A');
		mige = new JRadioButtonMenuItem("Edit Node");
		mige.setSelected(true);
		mige.setMnemonic('d');
		miadn = new JRadioButtonMenuItem("Add/Delete Node");
		miadn.setMnemonic('N');
		miade = new JRadioButtonMenuItem("Add/Delete Edge");
		miade.setMnemonic('E');

		bn.setToolTipText("New Graph");	
		bo.setToolTipText("Open Graph");
		bs.setToolTipText("Save Graph");
		bcu.setToolTipText("Cut");
		bco.setToolTipText("Copy");
		bpa.setToolTipText("Paste");
		baci.setToolTipText("Centered 2 Circle");
		bacr.setToolTipText("Cross");
		basp.setToolTipText("DynaSpring");
						
		mf.add(mifn);
		mf.add(mifo);
		mf.addSeparator();
		mf.add(mifsa);
		mf.add(mifs);
		mf.addSeparator();
		mf.add(mifq);
		mb.add(mf);
		me.add(miecu);
		me.add(mieco);
		me.add(miepa);
		me.addSeparator();
		me.add(mies);
		me.add(mied);
		mb.add(me);
		bg.add(mige);
		bg.add(miadn);
		bg.add(miade);
		mg.add(mige);
		mg.add(miadn);
		mg.add(miade);
		mb.add(mg);
		ma.add(mias);
		ma.add(miaci);
		ma.add(miace);
		ma.add(miacr);
		ma.add(miasp);
		ma.add(miad);
		ma.addSeparator();
		ma.add(miag);
		mb.add(ma);
		mh.add(mihh);
		mh.add(miha);
		mb.add(mh);
		setJMenuBar(mb);
		
		tb.add(bn);
		tb.add(bo);
		tb.add(bs);
		tb.addSeparator();
		tb.add(bcu);
		tb.add(bco);
		tb.add(bpa);
		tb.addSeparator();
		tb.add(baci);
		tb.add(bacr);
		tb.add(basp);
		
		tbp.setLayout(new BorderLayout());
		tbp.add("North",tb);
		tbp.add("Center",gc);
		tbp.add("South",status);
		c.add(tbp);
		
		bn.addActionListener(alnew);	
		mifn.addActionListener(alnew);
		bo.addActionListener(alopen);	
		mifo.addActionListener(alopen);		
		mifsa.addActionListener(alsaveas);
		bs.addActionListener(alsave);
		mifs.addActionListener(alsave);
		mifq.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {onExit();}});
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {onExit();}});	
		bcu.addActionListener(alcut);
		miecu.addActionListener(alcut);
		bco.addActionListener(alcopy);
		mieco.addActionListener(alcopy);
		bpa.addActionListener(alpaste);
		miepa.addActionListener(alpaste);
	  mige.addActionListener(alee);
		miadn.addActionListener(aladn);
		miade.addActionListener(alade); 
    mies.addActionListener(alsall);
		mied.addActionListener(aldall);
		mias.addActionListener(alas);
		miaci.addActionListener(alaci);
		miace.addActionListener(alce);
		baci.addActionListener(alce);
		miacr.addActionListener(alcr);
		bacr.addActionListener(alcr);
		miasp.addActionListener(als);
		miad.addActionListener(ald);
		basp.addActionListener(ald);
		miag.addActionListener(alg);
		mihh.addActionListener(alhh);
		miha.addActionListener(alha);
	}

	public Graph getGraph() {return g;}
	public void setGraph(Graph g) {
	  this.g.deleteObservers();
		this.g = g;
		gc.setGraph(g);
		sg = g.getSelection();
	}
}