package graphomat.util;
import java.util.Hashtable;
import java.util.Enumeration;
import java.io.*;

/**
 *Stores a set of random Objects. Is able to give a <code>
 *Enumeration</code> of all stored Objects.
 */
public class HashSet implements Serializable{
	private Hashtable ht;
	private int count;
	public HashSet()	{ht = new Hashtable();}
	public HashSet(int x) {ht = new Hashtable(x);}
	/**
	 *Adds a new Object to the Set.
	 */
	public void add(Object o) {ht.put(o,o); count++;}
	/**
	 *Delets an Object of the Set.
	 */
	public void delete(Object o) {ht.remove(o); count--;}
	/**
	 *Checks wether the Object is in the Set.
	 */
	public boolean contains(Object o) {return ht.containsKey(o);}
	/**
	 *Returns an <code>Enumeration</code> of all objects.
	 */
	public Enumeration getEnum() {return ht.keys();}
	/**
	 *Returns the number of Objects in the Set.
	 */
	public int getCount()	{return count;}
	
	public String toString() {
		StringBuffer output = new StringBuffer(" ");
		Enumeration enum = getEnum();
		
		while (enum.hasMoreElements()) {
			output.append(enum.nextElement());
			if (enum.hasMoreElements()) output.append(", ");
		}
		return output.toString();
	}
}